package com.example.appforkids.screen.main

import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.setValue
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.example.appforkids.data.HttpClient
import com.example.appforkids.data.Models.Response.UserResponse
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.launch

class ClickerViewModel:ViewModel() {
    val user = MutableStateFlow<UserResponse?>(null)

    fun getUser(id:Int){
        viewModelScope.launch {
            user.emit(HttpClient.retrofitInstance.getUser(id))
        }
    }
    fun setClick(){
        viewModelScope.launch {
            if (user.value == null) return@launch
            HttpClient.retrofitInstance.registerClick(user.value!!.id)
            val click = user.value!!.clicks + 1;
            user.emit(user.value!!.copy(clicks = click))
        }
    }
}